(**************************************************************************

   	This file is part of the AtomicDensityMatrix package for Mathematica
    Copyright (C) 2004-2014 Simon M. Rochester <simon@rochesterscientific.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************)


BeginPackage["AtomicDensityMatrix`LevelDiagram`",
    {"Splines`",
        "AtomicDensityMatrix`",
        "AtomicDensityMatrix`Common`",
        "AtomicDensityMatrix`TensorAlgebra`", "AtomicDensityMatrix`AtomicSystem`"}]

(* ::Subsection:: *)
(*Usage messages*)

PixelHeight::usage = ""

AbsoluteHeight::usage = ""

AbsoluteWidth::usage = ""

spaceLabels::usage = ""

ConnectArc::usage = ""

TakeFraction::usage = "TakeFraction[\!\(\*
StyleBox[\"list\", \"TI\"]\),\!\(\*
StyleBox[\"f\", \"TI\"]\)] takes a fraction \!\(\*
StyleBox[\"f\", \"TI\"]\) of the elements of \!\(\*
StyleBox[\"list\", \"TI\"]\), rounded to the nearest element."

PointTriangle::usage = "Draws a filled triangle made up of individual points."

LevelDiagram::usage = ""

ArrowStyle::usage = ""

StaticArrowStyle::usage = ""

ExtraArrows::usage = ""

ArrowSpacing::usage = ""

ArrowSetback::usage = ""

LevelStyle::usage = ""

ParityOffset::usage = ""

ArcRadius::usage = ""

MaxArcSlope::usage = ""

LevelSpacing::usage = ""

LevelLength::usage = ""

AbsoluteScale::usage = ""

AbsoluteSize::usage = ""

AdjustArrows::usage = ""

MLabel::usage = ""

JLabel::usage = ""

FLabel::usage = ""

MLabelPosition::usage = ""

JLabelOffset::usage = ""

QN::usage = ""

LevelLabelStyle::usage = ""

SuppressOffResonantCouplings::usage = ""

PopulationFunction::usage = ""

PopulationStyle::usage = ""

ArrowFunction::usage = ""

ArrowOffset::usage = ""

QuantumNumberSymbols::usage = ""

QuantumNumberSubscripts::usage = ""

RibbonArrow::usage = ""

SquiggleArrow::usage = ""

Frequency::usage = ""

Amplitude::usage = ""

DeleteAllDuplicates::usage = ""

PopAppend::usage = ""

(* ::Section:: *)
(*Implementation*)

(* ::Subsection:: *)
(*Begin private context*)

Begin["`Private`"]

(* ::Subsection:: *)
(*Level Diagram*)

(*PixelHeight[r_]:=Module[{h,p,min,max},
h=Length[r];
p=Flatten@Position[r,{{255,255,255}..}];
For[min=1,min<h&&min<=Length[p]&&min== p[[min]],min++];
For[max=h, max>1&&-(max-h-1)<=Length[p]&&max==p[[max-h-1]],max--];
max-min+1]

PixelHeight[r_] :=
 Length[r] - 
  Position[r, Except[{{255, 255, 255} ..}], 1, 1, Heads -> False][[1, 
    1]] - Position[Reverse@r, Except[{{255, 255, 255} ..}], 1, 1, 
    Heads -> False][[1, 1]] + 2*)

PixelHeight[r_] :=
    Subtract @@
        Flatten[Position[r, Except[{{255, 255, 255} ..}], 1,
            Heads -> False]][[{-1, 1}]] + 1

AbsoluteHeight[expr_] := PixelHeight@Rasterize[expr, Background -> White, ImageResolution -> 72][[1, 1]]

AbsoluteWidth[expr_] := PixelHeight@Transpose@Rasterize[expr, Background -> White, ImageResolution -> 72][[1, 1]]

spaceLabels[lab_, scale_] := Module[{h, m, y},
    (
        h = Total[#[[All, 1]]];
        m = Mean[#[[All, 2, 2, 2, 2]]];
        y = m - h / 2;
        Table[
            ReplacePart[i, {2, 2, 2, 2} -> (y += i[[1]]) - i[[1]] / 2][[2]],
            {i, #}]
    )& /@ Split[{AbsoluteHeight[#[[1]]] / scale, #}& /@ SortBy[lab, #[[2, 2, 2]]&], #2[[2, 2, 2, 2]] - #1[[2, 2, 2, 2]] < (#2[[1]] + #1[[1]]) / 2&]
]

ConnectArc[{p1_, p2_}, o_] :=
    Cases[Flatten[
        ParametricPlot[
            SplineFit[{p1, Mean[{p1, p2}] + o {{0, -1}, {1, 0}}.(p2 - p1),
                p2}, Bezier][x], {x, 0, 2}][[1]]], Line[_]] /. Line -> Arrow

TakeFraction[expr_, x_] := Take[expr, Round[x Length[expr]]]

PointTriangle[{x0_, y0_}, n_, s_] := Flatten@Table[Point[s {x, y} + {x0, y0}], {y, 0, n - 1}, {x, -(n - y - 1) / 2, (n - y - 1) / 2}]

RibbonArrow[{{x1_, y1_}, {x2_, y2_}}, w_] := Module[{ah = .15(y2 - y1), aw = .04(y2 - y1)}, Polygon[{{x1 - w / 2, y1}, {x1 + w / 2, y1}, {x2 + w / 2, y2 - ah}, {x2 + w / 2 + aw, y2 - ah}, {x2, y2}, {x2 - w / 2 - aw, y2 - ah}, {x2 - w / 2, y2 - ah}, {x1 - w / 2, y1}}]
]

Options[SquiggleArrow] = {Frequency -> 20, Amplitude -> .01, Arrowheads -> 1};

SquiggleArrow[{p1 : {p1x_, p1y_}, p2 : {p2x_, p2y_}}, opts : OptionsPattern[]] := Module[{f = OptionValue[Frequency], a = OptionValue[Amplitude], len = Norm[p2 - p1], arr = (Abs[If[Head[#1] =!= List, {0, #1}, #1]]&)[OptionValue[Arrowheads]], q1 = p1, q2 = p2},
    If[MatchQ[arr, {x_ /; x != 0, 0}], arr = Reverse[arr];{q1, q2} = Reverse[{q1, q2}]];
    Quiet[GeometricTransformation[Translate[{
        ParametricPlot[{a Sin[2\[Pi] f t], t}, {t, a arr[[1]]4.2, len - a arr[[2]]4.2}][[1, 1, -1, -1]], If[arr[[2]] == 0., {}, Translate[Polygon[a arr[[2]]5.25{{0, 0}, {.265, -1}, {0, -.9}, {-.265, -1}, {0, 0}}], {0, len}]],
        If[arr[[1]] == 0., {}, Polygon[a arr[[1]]5.25{{0, 0}, {.265, 1}, {0, .9}, {-.265, 1}, {0, 0}}]]},
        q1], RotationTransform[{{0, 1}, q2 - q1}, q1]], {RotationMatrix::"degen"}]
]

QN[state_, sym_, sub_, labs_] :=
    Which[
        sub === True, Subscript[sym, StateLabel[state]],
        sub === Primes, Derivative[Position[labs, StateLabel[state]][[1, 1]] - 1][sym],
        True, sym
    ]

If[$VersionNumber < 7., DeleteDuplicates[expr_] := Tally[expr][[All, 1]]];

DeleteAllDuplicates[e_, patt_] :=
    Delete[e, Flatten[Rest@Position[e, #]& /@ DeleteDuplicates@Cases[e, patt, Infinity], 1]]

SetAttributes[PopAppend, HoldFirst]

PopAppend[list_] := (list = RotateLeft[list];Last[list])

Options[LevelDiagram] =
    Join[{Arrowheads -> Automatic, ArrowStyle -> {},
        StaticArrowStyle -> {}, ArrowSpacing -> .05,
        ExtraArrows -> {}, LevelStyle -> {}, LevelLength -> .8,
        LevelSpacing -> .2, AbsoluteScale -> 50, MLabel -> None,
        MLabelPosition -> Automatic, FLabel -> None, JLabel -> None,
        JLabelOffset -> None, LevelLabelStyle -> {}, ParityOffset -> True, MaxArcSlope -> .2,
        ArcRadius -> -.5, SuppressOffResonantCouplings -> True,
        AdjustArrows -> False,
        PopulationFunction -> (TakeFraction[
            PointTriangle[#1 + {0, .05}, 7, .09], #2] &),
        PopulationStyle -> {PointSize[.0225]}, ArrowFunction -> Automatic,
        ArrowOffset -> Automatic, ArrowSetback -> 0,
        QuantumNumberSymbols -> {J, F, M},
        QuantumNumberSubscripts -> {True, True, False},
        ImagePadding -> {{Automatic, Automatic}, {All, All}}},
        DeleteCases[Options[Graphics], ImagePadding -> _]]

LevelDiagram[system : {_AtomicState..}] := LevelDiagram[system, DiagonalMatrix[Energy /@ system], {{0}}]

LevelDiagram[system : {_AtomicState..}, opts : OptionsPattern[]] := LevelDiagram[system, DiagonalMatrix[Energy /@ system], {{0}}, opts]

LevelDiagram[system : {_AtomicState..}, h_ /; !MatchQ[h, OptionsPattern[]], opts : OptionsPattern[]] := LevelDiagram[system, h, {{0}}, opts]

LevelDiagram[system : {_AtomicState..}, h_?VectorQ, rho_?OperatorQ, opts : OptionsPattern[]] := LevelDiagram[system, DiagonalMatrix[h], rho, opts]

LevelDiagram[
    system : {_AtomicState..},
    hlist : {{_?OperatorQ, ___Rule}..},
    rho_?OperatorQ,
    opts : OptionsPattern[]] :=
    Module[
        {plots},
        plots = Prepend[
            LevelDiagram[system, #[[1]], {{0}}, Sequence @@ Rest[#], opts]& /@ hlist,
            LevelDiagram[system, hlist[[1, 1]], rho, Sequence @@ Rest[hlist[[1]]], opts]
        ];
        DeleteAllDuplicates[
            Show[plots, ImagePadding -> Map[Max, Transpose[ImagePadding /. AbsoluteOptions[#, ImagePadding]& /@ plots, {3, 1, 2}], {2}],
                ImageSize -> Max[ImageSize /. AbsoluteOptions[#, ImageSize]& /@ plots]], Text[__] | Line[{_, _}]
        ]
    ]

LevelDiagram[system : {_AtomicState..}, h_?OperatorQ, rho_?OperatorQ,
    opts : OptionsPattern[]] :=
    Module[ {allhfs, alllevels, arcrad, arf, arr, arrowfunc,
        arrowheads,
        arrowoff, arrowsetback, arrows, arrows0, arrsty, f, flab,
        flabopt,
        flabwidth, fpos, freqs, fsub, imagesize, index, ip, j, jlab,
        jlabopt, jlabwidth, jpos, jsub, jlaboffsetopt, jlaboffset,
        labsty,
        levels, levsty, m, matelem, mixing, mlab, mlabopt, msub,
        mlabelpos,
        noflab, nojlab, nudge, popfunc, pops, popsty, pos, thisarrsty,
        width, x1, x2, xmax, xmin, y1, y2, ymax, ymid, ymin, top,
        bottom,
        maxfstatecrit, bottomheight, topheight, basesty},
    (*******Styles*******)
        labsty = Replace[OptionValue[LabelStyle], List -> Sequence, {1},
            Heads -> True];
        levsty =
            Replace[If[ Head[#] =!= List,
                {#},
                #
            ], {} -> {{}}] &@
                OptionValue[LevelStyle];
        popsty =
            Replace[OptionValue[PopulationStyle], List -> Sequence, {1},
                Heads -> True];
        basesty =
            Replace[OptionValue[BaseStyle], List -> Sequence, {1},
                Heads -> True];
        arrsty =
            Replace[If[ Head[#] =!= List,
                {#},
                #
            ], {} -> {{}}] &@
                OptionValue[ArrowStyle];
        {j, f, m} = OptionValue[QuantumNumberSymbols];
        {jsub, fsub, msub} = OptionValue[QuantumNumberSubscripts];
        (*******Make the levels*******)
        alllevels = Split[StateLabel[system]][[All, 1]];
        pos = Transpose@{(OptionValue[LevelLength] +
            OptionValue[LevelSpacing]) M /@ system,
            Tr[h, List] /.
                MapIndexed[Energy[#1] -> (#2[[1]] - 1) &, alllevels]} /.
            M[_] -> 0;
        xmin = Min[pos[[All, 1]]] - OptionValue[LevelLength] / 2;
        xmax = Max[pos[[All, 1]]] + OptionValue[LevelLength] / 2;
        width = xmax - xmin;
        If[ DefinedQ[system, Parity] && OptionValue[ParityOffset],
            pos = MapThread[
                If[Parity[#1] === Even,
                    #2 - {(width + OptionValue[LevelSpacing]) / 2, 0},
                    #2 + {(width + OptionValue[LevelSpacing]) / 2, 0}
                ]&, {system, pos}];
            xmin = Min[pos[[All, 1]]] - OptionValue[LevelLength] / 2;
            xmax = Max[pos[[All, 1]]] + OptionValue[LevelLength] / 2;
            width = xmax - xmin;
        ];
        ymin = Min[pos[[All, 2]]];
        ymax = Max[pos[[All, 2]]];
        ymid = (ymax - ymin) / 2;
        levels = (Line[{#, #} +
            OptionValue[LevelLength] {{-.5, 0}, {.5, 0}}]) & /@
            pos;
        levsty = PadRight[levsty, Length[levels], levsty];
        levels =
            ReplacePart[levels, Position[levsty, None | False] -> {}];
        levsty = levsty /. None | False -> {};
        (*******Make the M labels*******)
        mlabopt =
            PadRight[{}, Length[system],
                Replace[OptionValue[MLabel], All -> True]];
        mlabopt =
            MapThread[
                Switch[#1, True | Automatic | Short,
                    If[ DefinedQ[#2, M],
                        If[ #1 =!= Short || M[#2] == -F[#2],
                            QN[#2, m, msub, alllevels] == M[#2],
                            M[#2]
                        ],
                        ""
                    ],
                    False | None, "", _, #1] &, {mlabopt, system}];
        If[ MatchQ[OptionValue[MLabelPosition], Top | Bottom],
            maxfstatecrit =
                And @@ StateParameters[DeleteParameter[SelectState[system, F -> Max[F /@ system]], M]] /. Rule -> Equal;
            mlabopt = MapThread[If[StateMatchQ[#1, maxfstatecrit], #2, ""] &, {system, mlabopt}];
        ];
        mlabelpos =
            PadRight[{}, Length[mlabopt], OptionValue[MLabelPosition]];
        mlabelpos = If[ Head[#] === List,
            #,
            {#, {0, 0}}
        ] & /@ mlabelpos;
        top = Max[pos[[All, 2]]];
        bottom = Min[pos[[All, 2]]];
        mlabelpos =
            MapThread[(Switch[#1[[1]], Top, {#2[[1]], top},
                Bottom, {#2[[1]], bottom},
                Automatic, #2] + #1[[2]] &), {mlabelpos, pos}];
        mlab = Union@
            If[ Union[mlabopt] === {""},
                {},
                MapThread[
                    Text[#2, #1, {If[ M[#3] === -F[#3] && OptionValue[MLabel] === Short,
                        .75,
                        0
                    ], .1 -
                        1.3 Sign[#1[[2]] - ymid - 10^-6]}] &, {mlabelpos,
                    mlabopt, system}]
            ];
        bottomheight =
            If[ #[[1]] <= Min[pos[[All, 2]]] && #[[2]] =!= "",
                AbsoluteHeight[
                    Text@TraditionalForm@Style[#[[2]], Black, labsty, basesty]],
                0
            ] &@Min@Transpose@{mlabelpos[[All, 2]], mlabopt};
        topheight =
            If[ #[[1]] >= Max[pos[[All, 2]]] && #[[2]] =!= "",
                AbsoluteHeight[
                    Text@TraditionalForm@Style[#[[2]], Black, labsty, basesty]],
                0
            ] &@Max@Transpose@{mlabelpos[[All, 2]], mlabopt};
        (*******Make the F labels*******)
        allhfs = Union[{StateLabel[#], F[#]} & /@ system];
        flabopt =
            Replace[OptionValue[
                FLabel], (Automatic | All |
                True) -> (If[ DefinedQ[#, F],
                QN[#, f, fsub, alllevels] == F[#],
                ""
            ] & /@ (SelectState[system, StateLabel -> #[[1]],
                F -> #[[2]]] & /@ allhfs))];
        fpos = Mean /@ (Extract[pos, #] & /@
            StatePosition[system, StateLabel -> #[[1]], F -> #[[2]]] & /@
            allhfs);
        noflab =
            MatchQ[flabopt, None | False] || Union[flabopt] === {""};
        flabwidth =
            If[ noflab,
                0,
                Max[AbsoluteWidth[
                    Text@TraditionalForm@Style[#, Black, labsty, basesty]] & /@
                    flabopt]
            ];
        flab = If[ noflab,
            {},
            spaceLabels[
                MapThread[
                    Text[#2,
                        Offset[{-.25 flabwidth, 0}, {xmin, #1[[2]]}], {1,
                        0}] &, {fpos, flabopt}],
                OptionValue[AbsoluteScale]]
        ];
        (*******Make the J labels*******)
        jlabopt =
            Replace[OptionValue[
                JLabel], (Automatic | All |
                True) -> (If[ DefinedQ[#, J],
                QN[#, j, jsub, alllevels] == J[#],
                ""
            ] & /@ (SelectState[system, #] & /@ alllevels))];
        jpos = {xmin,
            Mean[Union[#[[All, 2]]]]} & /@ (Extract[pos, #] & /@
            StatePosition[system, #] & /@ alllevels);
        jlaboffsetopt =
            Replace[OptionValue[
                JLabelOffset] /. (Automatic | None | False) -> {{0, 0}},
                p : {_?NumericQ, _?NumericQ} -> {p}];
        jlaboffset = PadRight[{}, Length[jlabopt], jlaboffsetopt];
        nojlab =
            MatchQ[jlabopt, None | False] || Union[jlabopt] === {""};
        jlabwidth =
            If[ nojlab,
                0,
                Max[AbsoluteWidth[
                    Text@TraditionalForm@Style[#, Black, labsty, basesty]] & /@
                    jlabopt]
            ];
        jlab = If[ nojlab,
            {},
            spaceLabels[
                MapThread[
                    Text[#2,
                        Offset[{-1.2 flabwidth - .2 jlabwidth, 0}, #1], {1,
                        0}] &, {jpos + jlaboffset, jlabopt}],
                OptionValue[AbsoluteScale]]
        ];
        imagesize = (OptionValue[ImageSize] /.
            Automatic ->
                OptionValue[AbsoluteScale] width) + (OptionValue[
            ImagePadding][[1, 1]] /.
            Automatic -> -OptionValue[AbsoluteScale] If[ nojlab,
                0,
                Clip[Min[(jlaboffset)[[All, 1]]], {-\[Infinity], 0}]
            ] +
                1.15 flabwidth + 1.1 jlabwidth + 2) + (OptionValue[
            ImagePadding][[1, 2]] /. Automatic -> 2);
        (*******Make the arrows*******)
        mixing = Join[
            DeleteCases[
                Position[h, x_ /; ! PossibleZeroQ[x], {2}, Heads -> False], {x_,
                x_}], {StatePosition[system, Sequence @@ #[[1]]][[1, 1]],
                StatePosition[system, Sequence @@ #[[2]]][[1, 1]]} & /@
                OptionValue[ExtraArrows]];
        arcrad =
            RotateRight[If[ Head[#] === List,
                #,
                {#}
            ] &@OptionValue[ArcRadius]];
        arrowheads =
            Arrowheads[
                OptionValue[Arrowheads] /.
                    Automatic -> {-.2, .2} 36 / imagesize] /.
                AbsoluteSize[x_] -> x / (OptionValue[AbsoluteScale] width);
        arrowoff =
            If[ MatrixQ[#] || # === Automatic,
                {#},
                #
            ] &@(OptionValue[
                ArrowOffset] /. {} -> Automatic);
        arrowsetback = EnsureList[OptionValue[ArrowSetback]];
        arrows0 = Flatten[Reap[(index = #;
        {{x1, y1}, {x2, y2}} =
            pos[[index]];
        If[ x1 > x2 || (x1 == x2 &&
            y1 > y2) || (thisarrsty = PopAppend[arrsty]) ===
            None,
            {},
            thisarrsty =
                Replace[thisarrsty, List -> Sequence, {1}, Heads -> True];
            If[ y1 > y2,
                index = Reverse@#;
                {{x1, y1}, {x2, y2}} =
                    pos[[index]]
            ];
            matelem = TrigToExp@Extract[h, index];
            freqs = Union[
                Cases[{matelem},
                    a_ E^(Complex[r_, x_?NumericQ] t) /; r == 0 -> {x,
                        a,
                        Directive[]}, \[Infinity]]] /. {} -> {{(y2 - y1),
                matelem, OptionValue[StaticArrowStyle]}};
            If[ OptionValue[SuppressOffResonantCouplings],
                freqs = DeleteCases[freqs, f_ /; Negative[f[[1]]]]
            ];
            arr = ({{{x1, y1}, {x2,
                y1 + #[[1]]}} + (PopAppend[arrowoff] /.
                Automatic ->
                    OptionValue[ArrowSpacing] OptionValue[LevelLength] {{1, 0}, {-1, 0}} Order[x1, x2]), #[[2]]}) & /@ freqs;
            (*Do arrow setback*)
            arr = Table[{If[ #2 >= 0,
                {arr[[i, 1, 1]], {#2 / #1, 1 - #2 / #1}.arr[[i, 1]]},
                {{1 + #2 / #1, -#2 / #1}.arr[[i, 1]], arr[[i, 1, 2]]}
            ],
            arr[[i, 2]]}&[Norm[Subtract @@ arr[[i, 1]]], PopAppend[arrowsetback]], {i, Length[arr]}];
            (*output with style*)
            MapThread[
                Sow[{Replace[#2[[3]], List -> Sequence, {1},
                    Heads -> True], thisarrsty, arf[#1]}] & , {arr, freqs}]
        ];) & /@ mixing][[2]]];
        If[ OptionValue[AdjustArrows] && arrows0 =!= {},
            arrows0 =
                SortBy[arrows0, {#[[-1, 1, 1]], -#[[-1, 1, 2, 2]]} &];
            arrows0 = Split[arrows0, #1[[-1, 1, 1]] == #2[[-1, 1, 1]] &];
            arrows0 =
                Flatten[If[ Length[#] == 1,
                    #,
                    Table[#[[i]] /.
                        arf[{{x1_, y1_}, {x2_, y2_}}, a_] :> (nudge = .4 OptionValue[LevelLength] (i - 1) /
                            Length[#];
                        arf[{{x1 + Order[x1, x2 + 10^-6] nudge, y1}, {x2 + KroneckerDelta[x1, x2] nudge, y2}}, a]), {i,
                        Length[#]}]
                ] & /@ arrows0, 1];
            arrows0 =
                SortBy[arrows0, {#[[-1, 1, 2]], #[[-1, 1, 1, 2]]} &];
            arrows0 = Split[arrows0, #1[[-1, 1, 2]] == #2[[-1, 1, 2]] &];
            arrows0 =
                Flatten[If[ Length[#] == 1,
                    #,
                    Table[#[[i]] /.
                        arf[{{x1_, y1_}, {x2_, y2_}},
                            a_] :> (nudge = .4 OptionValue[LevelLength] (i - 1) /
                            Length[#];
                        arf[{{x1 + KroneckerDelta[x1, x2] nudge,
                            y1}, {x2 - Order[x1 + 10^-6, x2] nudge, y2}}, a]), {i,
                        Length[#]}]
                ] & /@ arrows0, 1];
        ];
        arrowfunc =
            OptionValue[ArrowFunction] /. Automatic -> (Arrow[#1] &);
        arrows =
            arrows0 /.
                arf -> (If[ Abs[Slope[#[[1]]]] <= OptionValue[MaxArcSlope],
                    ConnectArc[#[[1]], First[arcrad = RotateLeft[arcrad]]],
                    arrowfunc @@ #
                ] &);
        (*******Make the population indicators*******)
        popfunc =
            OptionValue[PopulationFunction] /.
                Automatic -> (Rectangle[#1 + {-.2, 0}, #1 + {.2, #2}] &);
        pops = If[ rho === {{0}},
            {},
            MapThread[popfunc, {pos, Tr[rho, List]}]
        ];
        (*******Make Graphics*******)
        ip = OptionValue[ImagePadding];
        Graphics[{Transpose[{levsty, levels}], {labsty, mlab, flab,
            jlab}, {arrowheads, arrows}, {popsty, pops}}, {ImageSize ->
            imagesize,
            ImagePadding -> {{ip[[1, 1]] /.
                Automatic -> 1.1 jlabwidth + 1.15 flabwidth + 2,
                ip[[1, 2]] /. Automatic -> 2}, {ip[[2, 1]] /.
                Automatic | All -> 1.5 bottomheight + 2,
                ip[[2, 2]] /. Automatic | All -> 1.3 topheight + 2}},
            Sequence @@
                DeleteCases[
                    FilterRules[Join[{opts}, Options[LevelDiagram]],
                        Options[Graphics]],
                    Alternatives @@ Options[Graphics]]}]
    ]

(* ::Subsection:: *)
(*End the private context*)

End[]

(* ::Section:: *)
(*Epilog*)

(* ::Text:: *)
(*This section protects exported symbols and ends the package.*)

(* ::Subsection:: *)
(*Protect exported symbols*)

(*Protect[Evaluate[$Context<>"*"]]*)

(* ::Subsection:: *)
(*End the package context*)

EndPackage[]
